use color_eyre::Result;

use crate::network::GhostRequest;
use crate::action::Action;
use crate::types::params::RpcParams;

#[derive(Debug)]
pub struct ChainNameRequest<'a>(pub GhostRequest<'a>);
impl<'a> ChainNameRequest<'a> {
    pub async fn send(self) -> Result<()> {
        let chain_name = self
            .0
            .send::<String>("system_chain", RpcParams::new())
            .await
            .ok()
            .map(|response| response.result);
        self.0.action_tx.send(Action::SetChainName(chain_name))?;
        Ok(())
    }
}
