use color_eyre::Result;

use crate::network::GhostRequest;
use crate::action::Action;
use crate::rpc_params;

#[derive(Debug)]
pub struct GenesisHashRequest<'a>(pub GhostRequest<'a>);
impl<'a> GenesisHashRequest<'a> {
    pub async fn send(self) -> Result<()> {
        let genesis_hash = self.0.send::<String>("chain_getBlockHash", rpc_params!["0"])
            .await
            .ok()
            .map(|response| response.result);
        self.0.action_tx.send(Action::SetGenesisHash(genesis_hash))?;
        Ok(())
    }
}
