use color_eyre::Result;

use crate::network::GhostRequest;
use crate::action::Action;
use crate::types::params::RpcParams;

#[derive(Debug)]
pub struct NodeNameRequest<'a>(pub GhostRequest<'a>);
impl<'a> NodeNameRequest<'a> {
    pub async fn send(self) -> Result<()> {
        let name = self
            .0
            .send::<String>("system_name", RpcParams::new())
            .await
            .ok()
            .map(|response| response.result);
        self.0.action_tx.send(Action::SetNodeName(name))?;
        Ok(())
    }
}
