use color_eyre::Result;

use crate::network::GhostRequest;
use crate::action::Action;
use crate::types::params::RpcParams;

#[derive(Debug)]
pub struct NodeVersionRequest<'a>(pub GhostRequest<'a>);
impl<'a> NodeVersionRequest<'a> {
    pub async fn send(self) -> Result<()> {
        let version = self
            .0
            .send::<String>("system_version", RpcParams::new())
            .await
            .ok()
            .map(|response| response.result);
        self.0.action_tx.send(Action::SetNodeVersion(version))?;
        Ok(())
    }
}
