use color_eyre::Result;

use crate::network::GhostRequest;
use crate::action::Action;
use crate::types::params::RpcParams;

#[derive(Debug)]
pub struct TxPoolRequest<'a>(pub GhostRequest<'a>);
impl<'a> TxPoolRequest<'a> {
    pub async fn send(self) -> Result<()> {
        let tx_pool = self
            .0
            .send::<Vec<String>>("author_pendingExtrinsics", RpcParams::new())
            .await
            .ok()
            .map(|response| response.result)
            .unwrap_or_default();
        self.0.action_tx.send(Action::SetPendingExtrinsicsLength(tx_pool.len()))?;
        Ok(())
    }
}
