#[macro_export]
macro_rules! rpc_params {
    ($($param:expr),*) => {{
        use crate::types::params::RpcParams;

        let mut params = RpcParams::new();
        $(
            if let Err(err) = params.insert($param) {
                panic!("parameter `{}` cannot be serialized: {:?}", stringify!($param), err);
            }
        )*
        params
    }}
}
